/**
 * Theme functions file.
 *
 * Contains handlers for navigation.
 */

jQuery(function($){
 	"use strict";
   	jQuery('.main-menu-navigation > ul').superfish({
		delay:       500,
		animation:   {opacity:'show',height:'show'},
		speed:       'fast'
   	});
});

function garden_care_open() {
	jQuery(".sidenav").addClass('show');
}
function garden_care_close() {
	jQuery(".sidenav").removeClass('show');
    jQuery( '.mobile-menu' ).focus();
}

function garden_care_menuAccessibility() {
	var links, i, len,
	    garden_care_menu = document.querySelector( '.nav-menu' ),
	    garden_care_iconToggle = document.querySelector( '.nav-menu ul li:first-child a' );
    
	let garden_care_focusableElements = 'button, a, input';
	let garden_care_firstFocusableElement = garden_care_iconToggle; // get first element to be focused inside menu
	let garden_care_focusableContent = garden_care_menu.querySelectorAll(garden_care_focusableElements);
	let garden_care_lastFocusableElement = garden_care_focusableContent[garden_care_focusableContent.length - 1]; // get last element to be focused inside menu

	if ( ! garden_care_menu ) {
    	return false;
	}

	links = garden_care_menu.getElementsByTagName( 'a' );

	// Each time a menu link is focused or blurred, toggle focus.
	for ( i = 0, len = links.length; i < len; i++ ) {
	    links[i].addEventListener( 'focus', toggleFocus, true );
	    links[i].addEventListener( 'blur', toggleFocus, true );
	}

	// Sets or removes the .focus class on an element.
	function toggleFocus() {
      	var self = this;

      	// Move up through the ancestors of the current link until we hit .mobile-menu.
      	while (-1 === self.className.indexOf( 'nav-menu' ) ) {
	      	// On li elements toggle the class .focus.
	      	if ( 'li' === self.tagName.toLowerCase() ) {
	          	if ( -1 !== self.className.indexOf( 'focus' ) ) {
	          		self.className = self.className.replace( ' focus', '' );
	          	} else {
	          		self.className += ' focus';
	          	}
	      	}
	      	self = self.parentElement;
      	}
	}
    
	// Trap focus inside modal to make it ADA compliant
	document.addEventListener('keydown', function (e) {
	    let isTabPressed = e.key === 'Tab' || e.keyCode === 9;

	    if ( ! isTabPressed ) {
	    	return;
	    }

	    if ( e.shiftKey ) { // if shift key pressed for shift + tab combination
	      	if (document.activeElement === garden_care_firstFocusableElement) {
		        garden_care_lastFocusableElement.focus(); // add focus for the last focusable element
		        e.preventDefault();
	      	}
	    } else { // if tab key is pressed
	    	if (document.activeElement === garden_care_lastFocusableElement) { // if focused has reached to last focusable element then focus first focusable element after pressing tab
		      	garden_care_firstFocusableElement.focus(); // add focus for the first focusable element
		      	e.preventDefault();
	    	}
	    }
	});   
}

jQuery(function($){
	$('.mobile-menu').click(function () {
	    garden_care_menuAccessibility();
  	});
	$('.search-toggle').click(function () {
	    garden_care_search_focus();
  	});
});

function garden_care_search_open() {
	jQuery(".search-outer").addClass('show');
}
function garden_care_search_close() {
	jQuery(".search-outer").removeClass('show');
}

function garden_care_search_focus() {
	var links, i, len,
	    garden_care_search = document.querySelector( '.search-outer' ),
	    garden_care_iconToggle = document.querySelector( '.search-outer input[type="search"]' );
	    
	let garden_care_focusableElements = 'button, a, input';
	let garden_care_firstFocusableElement = garden_care_iconToggle; // get first element to be focused inside menu
	let garden_care_focusableContent = garden_care_search.querySelectorAll(garden_care_focusableElements);
	let garden_care_lastFocusableElement = garden_care_focusableContent[garden_care_focusableContent.length - 1]; // get last element to be focused inside menu

	if ( ! garden_care_search ) {
    	return false;
	}

	links = garden_care_search.getElementsByTagName( 'a' );

	// Each time a menu link is focused or blurred, toggle focus.
	for ( i = 0, len = links.length; i < len; i++ ) {
	    links[i].addEventListener( 'focus', toggleFocus, true );
	    links[i].addEventListener( 'blur', toggleFocus, true );
	}

	// Sets or removes the .focus class on an element.
	function toggleFocus() {
      	var self = this;

      	// Move up through the ancestors of the current link until we hit .mobile-menu.
      	while (-1 === self.className.indexOf( 'nav-menu' ) ) {
	      	// On li elements toggle the class .focus.
	      	if ( 'li' === self.tagName.toLowerCase() ) {
	          	if ( -1 !== self.className.indexOf( 'focus' ) ) {
	          		self.className = self.className.replace( ' focus', '' );
	          	} else {
	          		self.className += ' focus';
	          	}
	      	}
	      	self = self.parentElement;
      	}
	}
    
	// Trap focus inside modal to make it ADA compliant
	document.addEventListener('keydown', function (e) {
	    let isTabPressed = e.key === 'Tab' || e.keyCode === 9;

	    if ( ! isTabPressed ) {
	    	return;
	    }

	    if ( e.shiftKey ) { // if shift key pressed for shift + tab combination
	      	if (document.activeElement === garden_care_firstFocusableElement) {
		        garden_care_lastFocusableElement.focus(); // add focus for the last focusable element
		        e.preventDefault();
	      	}
	    } else { // if tab key is pressed
	    	if (document.activeElement === garden_care_lastFocusableElement) { // if focused has reached to last focusable element then focus first focusable element after pressing tab
		      	garden_care_firstFocusableElement.focus(); // add focus for the first focusable element
		      	e.preventDefault();
	    	}
	    }
	});   
}